-- vehicule_utility_pack.ms
-- Par Antoine Pasquay
-- Version 2
-- Created On: 5/12/2002
-- Modified On: 25/01/2003
-- tested using Max 4.0
-------------------------------------------------------------------------------
-- Fichier requis : Alien.bmp
-------------------------------------------------------------------------------
-- Description:
-- Vhicule est un pack compos de 5 scripts :
-- historique :
-- version 1.0 : Remorqueur v1.1 & Rollin v1.0
-- 			1.1: Ajout de Reducteur V 1.2 Remorqueur v 1.2
--			1.2: Ajout de Chenilleur V 1.0, Remorqueur v 1.3
--			1.3: Ajout de la bta Synchroniseur. Mise a jour de l'aide. Changement de logo.
--			1.4: Chenilleur V1.1 , Synchroniseur V1.01.
--			1.5: Chenilleur V1.3 , Synchroniseur V1.1 Mise a jour de l'aide.
-- 			1.6: Chenilleur V 1.5
--			1.7: Inverseur V1.0 , Remorqueur V1.42
--			1.8: Synchroniseur V1.4 , Reducteur V1.5
--			1.9: Remorqueur V1.5
-- 			2.0: Calculeur V1.0
--			2.1: Chenilleur V1.5
-------------------------------------------------------------------------------
--
-- REMORQUEUR :
-- Remorqueur permet d'animer automatiquement la position d'un objet tracter 
-- par un autre. 
-- 
-------------------------------------------------------------------------------
--
-- ROLLIN :
-- Permet de faire tourner une roue proportionnellement a son dplacement absolu.
--
--------------------------------------------------------------------------------
--
-- INVERSEUR
--
-- Description:
-- Permet d'inverser les valeur d'un controleur de type Flott.Bezier et ce sur un intervalle donn.
-- Il peut prserver le mouvement au-dela de l'intervalle spcifi.
-- 
-- Limitations : ne fonctionne qu'avec des contrleurs de type Flott.Bezier.
--
--------------------------------------------------------------------------------
-- REDUCTEUR :
-- Permet de rduire ou effacer les cls de transformations de plusieurs objets simultanment.
--
--------------------------
-- $$$ START $$$
--------------------------
utility Vehicule "Vhicule V 2.0"
(
--------------------------
-- $$$$ REMORQUEUR $$$$
--------------------------
rollout Remorqueur "Remorqueur"
(	
group "Objets"
	(
	pickbutton pick_pilot "Choisir Tracteur" width:140
	pickbutton pick_remorq "Choisir Remorque" width:140
	)
group "Liaison"
	(
	radiobuttons distyp labels:#("Rigide     ","Souple") default:1 align:#left columns: 2
	spinner rem_dist "Distance: " type:#float range:[1,100000,100] fieldwidth:60 align:#right enabled: false
	spinner min_dist "Distance Min: " type:#float range:[0,100000,0] fieldwidth:60 align:#right enabled: false
	checkbox align "Aligner Z" checked: true across: 2
	checkbox flip "Basculer" checked: false align:#right
	)
	
group "Affichage"
	(
	checkbox updavie "Mettre  jour vues"
	spinner dum_tail "Taille factices :" type:#float range:[1,1000,10] fieldwidth:45 align:#right 
	)
	
group "Calcul"
	(
	spinner start "Dbut intervalle: " type:#integer range:[-9999,9998,animationRange.start] fieldwidth:38 align:#right
	spinner end "Fin intervalle: " type:#integer range:[-9998,9999,animationRange.end] fieldwidth:38 align:#right
	spinner step "Prcision: " type:#integer range:[1,50,2] fieldwidth:23 align:#right
	checkbox reduc_key "Rduire cls" width:140 checked: true
	spinner treshold "Seuil:" range:[0,50,0.5] fieldwidth:35 align:#right
	button go "Calculer" enabled:false width:140
	)

on Remorqueur open do
(
global ec1, ec2, rot
ec1 = 0
ec2 = 0
rot = eulerangles 180 0 0
)

on pick_pilot picked pil do
	(
	pick_pilot.text = pil.name
	ec1 = 1
	if ( ec1 + ec2 == 2 ) then 
		(
		go.enabled = true  
		rem_dist.enabled = true
		rem_dist.value = distance pick_pilot.object.pos pick_remorq.object.pos
		)
	)
	
on pick_remorq picked rem do
	(
	pick_remorq.text = rem.name
	ec2 = 1
	if ( ec1 + ec2 == 2 ) then 
		(
		go.enabled = true
		rem_dist.enabled = true
		rem_dist.value = distance pick_pilot.object.pos pick_remorq.object.pos
		)
	)

on go pressed do
	(
	undo "Remorqueur" on
	(
	s = pick_pilot.object
	b = pick_remorq.object
	pil = dummy pos: s.pos parent:s boxsize: [dum_tail.value, dum_tail.value, dum_tail.value]
	pil.name = uniquename "Pilote"
	rem = dummy pos: b.pos boxsize: [dum_tail.value, dum_tail.value, dum_tail.value]
	rem.name = uniquename "Remorque"
	pil.lookat = rem
	b.parent = rem
	if align.checked == true then
		(
		b.dir = normalize (b.pos - s.pos)
		in coordsys local rotate b rot
		)
	
	animate on 
		(
			for frame in start.value to end.value by step.value do
			(			
			if frame < step.value then (at time 0 (prev_pos = rem.pos))
			else (at time (frame-step.value) (prev_pos = rem.pos))
			at time frame 
			vn = normalize (prev_pos - s.pos)
			in coordsys world at time frame
			case distyp.state of
				(
				1: rem.pos = pil.pos + (vn * rem_dist.value)
				2: case of
					(
						(length (rem.pos - s.pos) >= rem_dist.value): rem.pos = pil.pos + (vn * rem_dist.value)
	 					(length (rem.pos - s.pos) <= min_dist.value): rem.pos = pil.pos + (vn * min_dist.value)
						(length (rem.pos - s.pos) <= rem_dist.value and length (rem.pos - s.pos) >= min_dist.value): rem.pos = rem.pos
					)
				)
			if updavie.checked then slidertime = frame
			)
		)
		if reduc_key.checked then reduceKeys rem.pos.controller treshold.value 1f start.value end.value
	)
	slidertime = 0
	)
		

on start changed val do
(
if val > end.value then end.value = val + 1
)

on end changed val do
(
if val < start.value then start.value = val - 1
)

on flip changed state do
(
if flip.checked then rot = eulerangles 0 0 0 else rot = eulerangles 180 0 0
)	
on distyp changed state do
	(
	if distyp.state == 2 then min_dist.enabled = true else min_dist.enabled = false
	)
on min_dist changed val do
(
if val > rem_dist.value then rem_dist.value = val
)

on rem_dist changed val do
(
if val < min_dist.value then min_dist.value = val
)
--
--	
)
--------------------------------------
-- $$$$ ROLLIN $$$$
--------------------------------------
rollout Rollin "Rollin"
(
	group "Objet"
	(
	pickbutton selobj "Choisir Roue" width:140
	label lab_rotaxis "Axe de rotation: " across:1
	radiobuttons rot_axis  labels:#("X","Y","Z") default:3 columns: 3
	spinner obj_radius "Rayon: " type:#float range:[1,1000,48] fieldwidth:45 align:#left
	checkbox detect "Dtecter rayon" width:140 enabled:false
	button center "Pivot au centre" width:140 enabled:false
	checkbox reverse "Inverser direction" align:#left
	checkbox seteuler "Assigner Euler" align:#left
	)
	
	group "Gnral"
	(
	spinner calc_start "Dbut intervalle: " type:#integer range:[-9999,9998,animationRange.start] fieldwidth:47 align:#right
	spinner calc_end "Fin intervalle: " type:#integer range:[-9998,9999,animationRange.end] fieldwidth:47 align:#right
	label t1 "Calculer toutes les"
	spinner step "N image: " type:#integer range:[1,50,2] fieldwidth:47 align:#right
	checkbox reduc_key "Rduire cl" checked: true
	spinner treshold "Seuil:"   width:60 range:[0,1000,1]   align:#right
	button go "ROULER !" enabled:false width:140
	)
		
on rollin open do
(
global xvector, yvector,zvector
global xradius, yradius,zradius
xvector = [0,1,1]
yvector = [1,0,1]
zvector = [1,1,0]
)

on selobj picked obj do
(
if (superClassOf obj == geometryClass) then
	(
	global animated_object
	animated_object = obj
	selobj.text = obj.name
	detect.enabled = true
	detect.state = false
	center.enabled = true
	go.enabled = true
	)
)

on go pressed do
(
undo "Rollin" on
(
animate on
	(
	if seteuler.checked then
		(
		c = euler_xyz()
		animated_object.rotation.controller = c
		)

	cont = animated_object.rotation.controller
	for frame in animationRange.start to animationRange.end do
		(
		key_index = getkeyindex cont frame
		if (key_index) != 0 and (key_index) != 1 then (deleteKey cont key_index)
		)
	for frame in calc_start.value to calc_end.value by step.value do
		(
		if frame < step.value then (at time 0 (prev_pos = animated_object.pos))
		else (at time (frame-step.value) (prev_pos = animated_object.pos))
		at time frame (current_pos = animated_object.pos)
		covered_distance = distance prev_pos current_pos
		rotation = (180 * covered_distance)/(pi*obj_radius.value)
		in coordsys local at time frame
			(
			case rot_axis.state of
				(
				1: if reverse.checked == false then (rotate animated_object (eulerangles -rotation 0 0)) else (rotate animated_object (eulerangles rotation 0 0))
				2: if reverse.checked == false then (rotate animated_object (eulerangles 0 -rotation 0)) else (rotate animated_object (eulerangles 0 rotation 0))
				3: if reverse.checked == false then (rotate animated_object (eulerangles 0 0 -rotation)) else (rotate animated_object (eulerangles 0 0 rotation))
				)
			)
		)		
	)
	if reduc_key.checked == true then reduceKeys animated_object.rotation.controller treshold.value 1f calc_start.value calc_end.value
)
)

on center pressed do
(
addModifier animated_object (edit_mesh())
obj_center = [0,0,0]
for i in 1 to animated_object.numVerts do
	(
	obj_center += getVert animated_object i
	)
obj_center /= animated_object.numVerts
animated_object.pivot = obj_center
deleteModifier animated_object 1
)

on detect changed new_state do
(
if new_state == true then
	(
	addModifier animated_object (edit_mesh())
	obj_center = [0,0,0]
	for i in 1 to animated_object.numVerts do
		(
		obj_center += in coordsys local getVert animated_object i
		)
	obj_center /= animated_object.numVerts
	f_xvert_index = 1
	f_yvert_index = 1
	f_zvert_index = 1
	for i in 2 to animated_object.numVerts do
		(
		f_xvert_pos = in coordsys local getVert animated_object f_xvert_index
		f_yvert_pos = in coordsys local getVert animated_object f_yvert_index
		f_zvert_pos = in coordsys local getVert animated_object f_zvert_index
		new_vert_pos = in coordsys local getVert animated_object i
		if (distance (obj_center*xvector) (new_vert_pos*xvector)) > (distance (obj_center*xvector) (f_xvert_pos*xvector)) then f_xvert_index = i
		if (distance (obj_center*yvector) (new_vert_pos*yvector)) > (distance (obj_center*yvector) (f_yvert_pos*yvector)) then f_yvert_index = i
		if (distance (obj_center*zvector) (new_vert_pos*zvector)) > (distance (obj_center*zvector) (f_zvert_pos*zvector)) then f_zvert_index = i
		)
	f_xvert_pos = in coordsys local getVert animated_object f_xvert_index
	f_yvert_pos = in coordsys local getVert animated_object f_yvert_index
	f_zvert_pos = in coordsys local getVert animated_object f_zvert_index
	xradius = (distance (obj_center*xvector) (f_xvert_pos*xvector))
	yradius = (distance (obj_center*yvector) (f_yvert_pos*yvector))
	zradius = (distance (obj_center*zvector) (f_zvert_pos*zvector))
	deleteModifier animated_object 1
	case rot_axis.state of
		(
		1: obj_radius.value = xradius
		2: obj_radius.value = yradius
		3: obj_radius.value = zradius
		)
	)
)

on calc_start changed val do
(
if val > calc_end.value then calc_end.value = val
)

on calc_end changed val do
(
if val < calc_start.value then calc_start.value = val
)

on rot_axis changed state do
(
if (state == 1) and (detect.state == true) then obj_radius.value = xradius
if (state == 2) and (detect.state == true) then obj_radius.value = yradius
if (state == 3) and (detect.state == true) then obj_radius.value = zradius
)

)
--------------------------------------------
--  $$$$ INVERSEUR $$$$
--------------------------------------------
rollout inverseur "Inverseur"
(

	group "Piste"
	(
	button selobj "Choisir piste" width:140
	)
	group "Intervalle"
	(
	spinner calc_start "Dbut intervalle: " type:#integer range:[-9999,9998,animationrange.start] fieldwidth:35 align:#right
	spinner calc_end "Fin intervalle: " type:#integer range:[-9998,9999,animationrange.end] fieldwidth:35 align:#right
	)
	group "Ajuster tangentes"
	(
	checkbox kd_pres "Dbut" checked: true across:2
	checkbox ke_pres "Fin" checked: true 
	checkbox pres "Dcaler en aval" checked: true
	)
	
	group "Inversion"
	(
	radiobuttons typ_inv labels:#("Relative  ","Absolue") default:1 columns: 2 align:#left
	button go "Inverser !" enabled: false width:140
	)
-----------------------------------
on typ_op changed state do
(
if 	typ_op.state ==1 then
	(
	typ_inv.enabled = true
	val.enabled = false
	incl_deb.enabled = false
	incl_fin.enabled = false
	pres.checked = true
	)
else
	(
	typ_inv.enabled = false
	val.enabled = true
	incl_deb.enabled = true
	incl_fin.enabled = true
	pres.checked = false
	)
)	
-----------------------------------
on selobj pressed do
	(
	global tvp = trackview.pickTrackDlg ()
	if tvp != undefined then
		(
		clas = ClassOf tvp.anim
		if clas == bezier_float then
			(
			selobj.text = tvp.name
			global cont = tvp.anim
			print cont
			go.enabled = true
			)
		else
			(
			messagebox "Cette piste ne contient pas de cls ou de contrleur de type Bezier Flott." title: "Limitation !"
			)
		)
	)
-------------------------
on go pressed do
(
	undo "Inverseur" on
	(
		kd = getkeyindex cont calc_start.value
		if kd == 0 then
			(
			addnewkey cont calc_start.value
			)
		kd = getkeyindex cont calc_start.value
		kdv = getkey cont kd
		ofset_rev = 2*kdv.value
			
		ke = getkeyindex cont calc_end.value
		if ke == 0 then
			(
			addnewkey cont calc_end.value
			)
		ke = getkeyindex cont calc_end.value
		kev = getkey cont ke
		kevo = kev.value
		if kd_pres.checked == true then
			(
			kdv.inTangentType = kdv.outTangentType = #custom
			kdv.x_locked = kdv.y_locked = kdv.z_locked = false
			kdv.outtangent = - kdv.outtangent
			)
		------------------------
		for frame in calc_start.value to calc_end.value do
			(
			key_index = getkeyindex cont frame
			if (key_index) != 0 then 
				(
				vc = getkey cont key_index
				if typ_inv.state == 1 then (vc.value = -1*(vc.value - ofset_rev))else (vc.value = -vc.value)
				if vc.inTangentType == #custom and key_index != ke then vc.inTangent = - vc.inTangent
				if vc.outTangentType == #custom and key_index != ke then vc.outtangent = - vc.outTangent
				)
			)
			if ke_pres.checked == true then
				(
				kev.inTangentType = kev.outTangentType = #custom
				kev.x_locked = kev.y_locked = kev.z_locked = false
				kev.inTangent = - kev.inTangent
				)
			if pres.checked == true then 
				(	
				kep = getkeyindex cont calc_end.value
				kevp = getkey cont kep
				ofset_dec =	kevo - kevp.value
					
				for frame in (calc_end.value+1) to animationrange.end do
					(
					key_index = getkeyindex cont frame
					if (key_index) != 0 and (key_index) != ke then 
						(
						vc = getkey cont key_index
						vc.value = vc.value - ofset_dec
						)
					)
				)
------------------
	)
)
--------------------------------------------------------

on calc_start changed val do
(
if val > calc_end.value then calc_end.value = val
)

on calc_end changed val do
(
if val < calc_start.value then calc_start.value = val
)

---------------------------------------------------------
)

-------------------------------------
-- $$$$ REDUCTEUR $$$$
-------------------------------------
rollout Reducteur "Rducteur"
(
	group "Parmtres communs"
	(
	checkbox pb "Position" width:140 checked: true 
	checkbox rb "Rotation" width:140 checked: true
	checkbox sb "Echelle" width:140  
	checkbox mb "Modificateurs" width:140
	spinner start "Dbut intervalle: "  width:110 range:[-9999,9998,animationRange.start] type:#integer  align:#right
	spinner end "Fin intervalle: "  width:100 range:[-9998,9999,Animationrange.end] type:#integer  align:#right
	)
	group "Effacer"
	(
	checkbox cons_fin "Conserver Fin"
	button delall "Effacer cls" width:140
	)
	group "Rduction"
	(
	spinner treshold "Seuil :"   width:60 range:[0,1000,1]   align:#right
	button reduk "Rduire cls"  width:140
	)
--
-- reduc
--
on reduk pressed do
	(
	undo "Reducteur: reduc" on
		(
		--------------------------
		if pb.checked == true then 
			(
				for x in selection do
				(
				try (reduceKeys x.pos.controller treshold.value 1f start.value end.value) catch()
				)
			)	
		--------------------------
		if rb.checked == true then 
			(
				for x in selection do
				(
				try (reduceKeys x.rotation.controller treshold.value 1f start.value end.value) catch ()
				)
			)
		--------------------------
		if sb.checked == true then
			(
				for x in selection do
				(
				try (reduceKeys x.scale.controller treshold.value 1f start.value end.value) catch ()
				)
			)
		--------------------------
		if mb.checked == true then
			(
				for x in selection do
				(
				try (reduceKeys x.modifiers treshold.value 1f start.value end.value) catch ()
				)
			)
		--------------------------
		)
	)	
--
-- del
--
on delall pressed do
	(
	undo "Reducteur: del" on
		(
----------------------
		if pb.checked == true then 
			(
				for x in selection do
				(
					if cons_fin.checked == true then
					(
						try
						(
							selectkeys x.pos.controller end.value animationrange.end
							deleteTime x.pos.controller start.value end.value
							movekeys x.pos.controller (end.value - start.value) #selection
							deselectkeys x.pos.controller
							) catch()
						)
					else
					(
					try	(deleteTime x.pos.controller start.value end.value ) catch()
					)
				)
			)
		---------------------------
		if rb.checked == true then 
			(
				for x in selection do
				(
					if cons_fin.checked == true then
					(
						try
						(
							selectkeys x.rotation.controller end.value animationrange.end
							deleteTime x.rotation.controller start.value end.value
							movekeys x.rotation.controller (end.value - start.value) #selection
							deselectkeys x.rotation.controller
							) catch()
						)
					else
						(
						try	(deleteTime x.rotation.controller start.value end.value ) catch()
						)
					)
				)
		--------------------------
		if sb.checked == true then
			(
				for x in selection do
				(
					if cons_fin.checked == true then
						(
							try
							(
							selectkeys x.scale.controller end.value animationrange.end
							deleteTime x.scale.controller start.value end.value
							movekeys x.scale.controller (end.value - start.value) #selection
							deselectkeys x.scale.controller
							) catch()
						)
					else
					(
					try	(deleteTime x.scale.controller start.value end.value ) catch()
					)
				)
			)
		--------------------------
		if mb.checked == true then
			(
				for x in selection do
				(
					if cons_fin.checked == true then
						(
							try
							(
							selectkeys x.modifiers end.value animationrange.end
							deleteTime x.modifiers start.value end.value
							movekeys x.modifiersr (end.value - start.value) #selection
							deselectkeys x.modifiers
							) catch()
						)
					else
					(
					try	(deleteTime x.modifiers start.value end.value ) catch()
					)
				)
			)						
-----------------------------

		)
	)
--
-- Cancel
--
on start changed val do
(
if val > end.value then end.value = val
)

on end changed val do
(
if val < start.value then start.value = val
)
--
-- end
--
)
--------------------------------------------
--              Aide
--------------------------------------------
rollout hlp "Aides Vhicule"
(
-------------
button hlp_rem "Remorqueur" width:140
button hlp_rol "Rollin" width:140
button hlp_inv "Inverseur" width:140
button hlp_red "Rducteur" width:140

on hlp_rem pressed do 
(
messagebox "Tutorial: \nCrez un objet et animer le, avec une trajectoire ou par image-cl. \nCrez l'objet que vous voulez ''remorquer''. \n
Slectionnez votre 1er objet comme Tracteur. \nSlectionnez le 2me comme Remorque \nLa distance entre le Tracteur et la Remorque s'affiche. Vous pouvez la modifier mais le rsultat ne sera visible qu'aprs le calcul.\n
Cliquez sur Calculer !... Et votre remorque suit automatiquement votre tracteur, mme si celui-ci recule ! \n
Note : Si vous modifier la trajectoire du tracteur, il faut alors refaire un calcul. Effacer les assistants ''Pilote_xxx'' et ''Remorque_xxx''. \n
Bugs connus : le principe tant bas sur un controleur Observer, il peut se produire des phnomnes de basculement... \nJe n'ai malheureusement pas de solution pour l'instant. \n
Amliorations possibles : dlais de rponse de la remorque, distance animable, calcul interactif, limitation du pivotage de la remorque,\nchoix de l'alignement de l'axe de la remorque, bank pour la remorque... et traductions !"\
title: "Aide de remorqueur" beep: false
) 

on hlp_rol pressed do
(
messagebox "Choisissez une roue a l'aide du bouton prvu.
Choissiez l'axe. Si la roue est parent, la rotation se fera dans le repre local.
Si elle n'est pas parent, la rotation se fait dans le repre Univers de la scne.
Cliquez sur ''ROULER''. \n
Si aprs un calcul, la roue ne tourne pas dans le bon sens, annuler via CTRL + Z ou le bouton.
Cocher alors ''Inverser direction'' et relancer le calcul.
L'intervalle de calcul est par dfaut la dure de la scne en cours. Modifiez si ncessaire.
Si votre calcul n'a pas besoin d'tre trs prcis, augmenter ''N image'' ou ''Seuil''."\
title: "Aide de Rollin" beep: false
)

on hlp_inv pressed do
(
messagebox "Tutorial : \n
Slectionnez la piste dont vous voulez inverser des valeurs.
La piste doit tre de type ''Bezier Flott.''. Tout autre type est invalide.
Slectionnez l'intervalle sur lequel vous voulez inverser les valeurs.
Si vous cochez ''dbut'' et ''fin'' dans la section Ajuster tangentes,
les tangentes seront brises de faon a conserver au mieux le mouvement.
L'inversion peut se faire en mode relatif ou absolu.
En relatif, la valeurs sont invers par rapport  la valeur de la premire cl de l'intervalle.
En absolu, les valeurs sont multiplis par -1.
"\
title: "Aide de Inverseur" beep: false
)

on hlp_inv pressed do
(
messagebox "Tutorial : \n
La suppression ou rduction de cl peut se faire pour un intervalle.
Si vous cochez ''Modificateurs'', ce sont TOUTES les cls de TOUS 
les modificateurs de TOUS les objets slectionns qui seront affectes.

L'option conserver fin de Effacer laisse les cl au-del de l'intervalle
 leur position originale; valeurs et temps.
"\
title: "Aide de Rducteur" beep: false
)

------------------
)
------------------------------------
-- $$$$ A propos de VEHICULE $$$$
------------------------------------
rollout roabout "A propos de VEHICULE"
(
	group "Vhicule V 2.0"
	(
	bitmap chenill filename: "Alien.bmp"
	label l0l "Remorqueur version 1.5"
	label l02 "Rollin Version 1.1"
	label l03 "Inverseur Version 1.0"
	label l07 "Reducteur Version 1.3"
	label l08 "Auteur: Antoine PASQUAY"
hyperlink label_l09 "www.athanaze.com" align:#center address:"http://www.athanaze.fr.st" color:(color 70 70 255) hoverColor:(color 230 63 63)
	label l10 "E-mail :"
	hyperlink label_l11 "athanaze@fr.st" align:#center address:"mailto:athanaze@fr.st" color:(color 70 70 255) hoverColor:(color 230 63 63)

	)
	group "Rollin"
	(
	label l5 "Rollin'"
	label l6 "by Adam Wierzchowski" 
	label l7 "E-mail: asd@grafik.3D.pl" 
	label l8 "Web: www.asd.3D.pl"
	label l9 "Traduit par Antoine"
	)
)

---------------------------------
-- $$$$ MAIN UTILITY $$$$
--------------------------------
on Vehicule open do
(
addrollout Remorqueur rolledup: true
addrollout Rollin rolledup: true
addrollout Inverseur rolledup: true
addrollout Reducteur rolledup: true
addrollout hlp rolledup: true
addrollout roabout  rolledup: true
)

on Vehicule close do
(
removerollout Remorqueur
removerollout Rollin
removerollout Inverseur
removerollout Reducteur
removerollout hlp
removerollout roabout
)
--------------------------
-- $$$ END $$$
--------------------------
)